Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbthm.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbthm.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbthm.F90	(revision 3359)
@@ -29,5 +29,5 @@
    PRIVATE
 
-   PUBLIC   thermodynamics ! routine called in xxx.F90 module
+   PUBLIC   thermodynamics ! routine called in icbrun.F90 module
 
 CONTAINS
@@ -43,9 +43,9 @@
       INTEGER                         ::   kt          ! timestep number, just passed to print_berg
       !
-      REAL(wp)                        ::   M, T, W, L, SST, Vol, Ln, Wn, Tn, nVol, IC, Dn
-      REAL(wp)                        ::   Mv, Me, Mb, melt, dvo, dva, dM, Ss, dMe, dMb, dMv
-      REAL(wp)                        ::   Mnew, Mnew1, Mnew2, heat
-      REAL(wp)                        ::   Mbits, nMbits, dMbitsE, dMbitsM, Lbits, Abits, Mbb
-      REAL(wp)                        ::   xi, yj, zff, z1_rday, z1_e1e2, zdt, z1_dt, z1_dt_e1e2
+      REAL(wp)                        ::   zM, zT, zW, zL, zSST, zVol, zLn, zWn, zTn, znVol, zIC, zDn
+      REAL(wp)                        ::   zMv, zMe, zMb, zmelt, zdvo, zdva, zdM, zSs, zdMe, zdMb, zdMv
+      REAL(wp)                        ::   zMnew, zMnew1, zMnew2, zheat
+      REAL(wp)                        ::   zMbits, znMbits, zdMbitsE, zdMbitsM, zLbits, zAbits, zMbb
+      REAL(wp)                        ::   zxi, zyj, zff, z1_rday, z1_e1e2, zdt, z1_dt, z1_dt_e1e2
       INTEGER                         ::   ii, ij
       TYPE(iceberg)         , POINTER ::   this, next
@@ -67,85 +67,86 @@
          !
          pt => this%current_point
-         knberg = this%number(1)
+         nknberg = this%number(1)
          CALL interp_flds( pt%xi, pt%e1, pt%uo, pt%ui, pt%ua, pt%ssh_x, &
-            &              pt%yj, pt%e2, pt%vo, pt%vi, pt%va, pt%ssh_y, pt%sst, pt%cn, pt%hi, zff )
-         !
-         SST = pt%sst
-         IC  = MIN( 1._wp, pt%cn + rn_sicn_shift )     ! Shift sea-ice concentration       !!gm ???
-         M   = pt%mass
-         T   = pt%thickness                               ! total thickness
-       ! D   = (rn_rho_bergs/rho_seawater)*T ! draught (keel depth)
-       ! F   = T - D ! freeboard
-         W   = pt%width
-         L   = pt%length
-         xi  = pt%xi                                      ! position in (i,j) referential
-         yj  = pt%yj
-         ii  = INT( xi + 0.5 ) - nimpp + 1                    ! t-cell of the berg
-         ij  = INT( yj + 0.5 ) - njmpp + 1
-         Vol = T * W * L
+         &                 pt%yj, pt%e2, pt%vo, pt%vi, pt%va, pt%ssh_y, &
+         &                 pt%sst, pt%cn, pt%hi, zff )
+         !
+         zSST = pt%sst
+         zIC  = MIN( 1._wp, pt%cn + rn_sicn_shift )     ! Shift sea-ice concentration       !!gm ???
+         zM   = pt%mass
+         zT   = pt%thickness                               ! total thickness
+       ! D   = (rn_rho_bergs/pp_rho_seawater)*zT ! draught (keel depth)
+       ! F   = zT - D ! freeboard
+         zW   = pt%width
+         zL   = pt%length
+         zxi  = pt%xi                                      ! position in (i,j) referential
+         zyj  = pt%yj
+         ii  = INT( zxi + 0.5 ) - nimpp + 1                    ! t-cell of the berg
+         ij  = INT( zyj + 0.5 ) - njmpp + 1
+         zVol = zT * zW * zL
          zdt = berg_dt   ;   z1_dt = 1._wp / zdt
 
          ! Environment
-         dvo = SQRT( (pt%uvel-pt%uo)**2 + (pt%vvel-pt%vo)**2 )
-         dva = SQRT( (pt%ua  -pt%uo)**2 + (pt%va  -pt%vo)**2 )
-         Ss  = 1.5 * SQRT( dva ) + 0.1 * dva                ! Sea state      (eqn M.A9)
+         zdvo = SQRT( (pt%uvel-pt%uo)**2 + (pt%vvel-pt%vo)**2 )
+         zdva = SQRT( (pt%ua  -pt%uo)**2 + (pt%va  -pt%vo)**2 )
+         zSs  = 1.5 * SQRT( zdva ) + 0.1 * zdva                ! Sea state      (eqn M.A9)
 
          ! Melt rates in m/s (i.e. division by rday)
-         Mv = MAX( 7.62e-3*SST+1.29e-3*(SST**2)            , 0._wp ) * z1_rday   ! Buoyant convection at sides (eqn M.A10)
-         Mb = MAX( 0.58*(dvo**0.8)*(SST+4.0)/(L**0.2)      , 0._wp ) * z1_rday   ! Basal turbulent melting     (eqn M.A7 )
-         Me = MAX( 1./12.*(SST+2.)*Ss*(1+cos(rpi*(IC**3))) , 0._wp ) * z1_rday   ! Wave erosion                (eqn M.A8 )
+         zMv = MAX( 7.62e-3*zSST+1.29e-3*(zSST**2)            , 0._wp ) * z1_rday   ! Buoyant convection at sides (eqn M.A10)
+         zMb = MAX( 0.58*(zdvo**0.8)*(zSST+4.0)/(zL**0.2)      , 0._wp ) * z1_rday   ! Basal turbulent melting     (eqn M.A7 )
+         zMe = MAX( 1./12.*(zSST+2.)*zSs*(1+cos(rpi*(zIC**3))) , 0._wp ) * z1_rday   ! Wave erosion                (eqn M.A8 )
 
          IF( ln_operator_splitting ) THEN      ! Operator split update of volume/mass
-            Tn    = MAX( T - Mb*zdt , 0._wp )         ! new total thickness (m)
-            nVol  = Tn * W * L                        ! new volume (m^3)
-            Mnew1 = (nVol/Vol) * M                    ! new mass (kg)
-            dMb   = M - Mnew1                         ! mass lost to basal melting (>0) (kg)
-            !
-            Ln    = MAX( L - Mv*zdt , 0._wp )         ! new length (m)
-            Wn    = MAX( W - Mv*zdt , 0._wp )         ! new width (m)
-            nVol  = Tn * Wn * Ln                      ! new volume (m^3)
-            Mnew2 = (nVol/Vol) * M                    ! new mass (kg)
-            dMv   = Mnew1 - Mnew2                     ! mass lost to buoyant convection (>0) (kg)
-            !
-            Ln    = MAX( Ln - Me*zdt , 0._wp )        ! new length (m)
-            Wn    = MAX( Wn - Me*zdt , 0._wp )        ! new width (m)
-            nVol  = Tn * Wn * Ln                      ! new volume (m^3)
-            Mnew  = ( nVol / Vol ) * M                ! new mass (kg)
-            dMe   = Mnew2 - Mnew                      ! mass lost to erosion (>0) (kg)
-            dM    = M - Mnew                          ! mass lost to all erosion and melting (>0) (kg)
+            zTn    = MAX( zT - zMb*zdt , 0._wp )         ! new total thickness (m)
+            znVol  = zTn * zW * zL                        ! new volume (m^3)
+            zMnew1 = (znVol/zVol) * zM                    ! new mass (kg)
+            zdMb   = zM - zMnew1                         ! mass lost to basal melting (>0) (kg)
+            !
+            zLn    = MAX( zL - zMv*zdt , 0._wp )         ! new length (m)
+            zWn    = MAX( zW - zMv*zdt , 0._wp )         ! new width (m)
+            znVol  = zTn * zWn * zLn                      ! new volume (m^3)
+            zMnew2 = (znVol/zVol) * zM                    ! new mass (kg)
+            zdMv   = zMnew1 - zMnew2                     ! mass lost to buoyant convection (>0) (kg)
+            !
+            zLn    = MAX( zLn - zMe*zdt , 0._wp )        ! new length (m)
+            zWn    = MAX( zWn - zMe*zdt , 0._wp )        ! new width (m)
+            znVol  = zTn * zWn * zLn                      ! new volume (m^3)
+            zMnew  = ( znVol / zVol ) * zM                ! new mass (kg)
+            zdMe   = zMnew2 - zMnew                      ! mass lost to erosion (>0) (kg)
+            zdM    = zM - zMnew                          ! mass lost to all erosion and melting (>0) (kg)
             !
          ELSE                                         ! Update dimensions of berg
-            Ln = MAX( L -(Mv+Me)*zdt ,0._wp )         ! (m)
-            Wn = MAX( W -(Mv+Me)*zdt ,0._wp )         ! (m)
-            Tn = MAX( T - Mb    *zdt ,0._wp )         ! (m)
+            zLn = MAX( zL -(zMv+zMe)*zdt ,0._wp )         ! (m)
+            zWn = MAX( zW -(zMv+zMe)*zdt ,0._wp )         ! (m)
+            zTn = MAX( zT - zMb    *zdt ,0._wp )         ! (m)
             ! Update volume and mass of berg
-            nVol = Tn*Wn*Ln                           ! (m^3)
-            Mnew = (nVol/Vol)*M                       ! (kg)
-            dM   = M - Mnew                           ! (kg)
-            dMb = (M/Vol) * (W*   L ) *Mb*zdt         ! approx. mass loss to basal melting (kg)
-            dMe = (M/Vol) * (T*(W+L)) *Me*zdt         ! approx. mass lost to erosion (kg)
-            dMv = (M/Vol) * (T*(W+L)) *Mv*zdt         ! approx. mass loss to buoyant convection (kg)
+            znVol = zTn*zWn*zLn                           ! (m^3)
+            zMnew = (znVol/zVol)*zM                       ! (kg)
+            zdM   = zM - zMnew                           ! (kg)
+            zdMb = (zM/zVol) * (zW*   zL ) *zMb*zdt         ! approx. mass loss to basal melting (kg)
+            zdMe = (zM/zVol) * (zT*(zW+zL)) *zMe*zdt         ! approx. mass lost to erosion (kg)
+            zdMv = (zM/zVol) * (zT*(zW+zL)) *zMv*zdt         ! approx. mass loss to buoyant convection (kg)
          ENDIF
 
          IF( rn_bits_erosion_fraction > 0._wp ) THEN      ! Bergy bits
             !
-            Mbits   = pt%mass_of_bits                                               ! mass of bergy bits (kg)
-            dMbitsE = rn_bits_erosion_fraction * dMe                        ! change in mass of bits (kg)
-            nMbits  = Mbits + dMbitsE                                               ! add new bergy bits to mass (kg)
-            Lbits   = MIN( L, W, T, 40._wp )                                        ! assume bergy bits are smallest dimension or 40 meters
-            Abits   = ( Mbits / rn_rho_bergs ) / Lbits                           ! Effective bottom area (assuming T=Lbits)
-            Mbb     = MAX( 0.58*(dvo**0.8)*(SST+2.0)/(Lbits**0.2), 0.) * z1_rday    ! Basal turbulent melting (for bits)
-            Mbb     = rn_rho_bergs * Abits * Mbb                                 ! in kg/s
-            dMbitsM = MIN( Mbb*zdt , nMbits )                                       ! bergy bits mass lost to melting (kg)
-            nMbits  = nMbits-dMbitsM                                                ! remove mass lost to bergy bits melt
-            IF( Mnew == 0._wp ) THEN                                                ! if parent berg has completely melted then
-               dMbitsM = dMbitsM + nMbits                                           ! instantly melt all the bergy bits
-               nMbits  = 0._wp
+            zMbits   = pt%mass_of_bits                                               ! mass of bergy bits (kg)
+            zdMbitsE = rn_bits_erosion_fraction * zdMe                        ! change in mass of bits (kg)
+            znMbits  = zMbits + zdMbitsE                                               ! add new bergy bits to mass (kg)
+            zLbits   = MIN( zL, zW, zT, 40._wp )                                        ! assume bergy bits are smallest dimension or 40 meters
+            zAbits   = ( zMbits / rn_rho_bergs ) / zLbits                           ! Effective bottom area (assuming T=Lbits)
+            zMbb     = MAX( 0.58*(zdvo**0.8)*(zSST+2.0)/(zLbits**0.2), 0.) * z1_rday    ! Basal turbulent melting (for bits)
+            zMbb     = rn_rho_bergs * zAbits * zMbb                                 ! in kg/s
+            zdMbitsM = MIN( zMbb*zdt , znMbits )                                       ! bergy bits mass lost to melting (kg)
+            znMbits  = znMbits-zdMbitsM                                                ! remove mass lost to bergy bits melt
+            IF( zMnew == 0._wp ) THEN                                                ! if parent berg has completely melted then
+               zdMbitsM = zdMbitsM + znMbits                                           ! instantly melt all the bergy bits
+               znMbits  = 0._wp
             ENDIF
          ELSE                                                     ! No bergy bits
-            Abits   = 0._wp
-            dMbitsE = 0._wp
-            dMbitsM = 0._wp
-            nMbits  = pt%mass_of_bits                             ! retain previous value incase non-zero
+            zAbits   = 0._wp
+            zdMbitsE = 0._wp
+            zdMbitsM = 0._wp
+            znMbits  = pt%mass_of_bits                             ! retain previous value incase non-zero
          ENDIF
 
@@ -154,9 +155,11 @@
             z1_e1e2    = 1._wp / e1e2t(ii,ij) * this%mass_scaling
             z1_dt_e1e2 = z1_dt * z1_e1e2
-            melt    = ( dM - ( dMbitsE - dMbitsM ) ) * z1_dt   ! kg/s
-            berg_grid%floating_melt(ii,ij) = berg_grid%floating_melt(ii,ij) + melt    * z1_e1e2    ! kg/m2/s
-            heat = melt * pt%heat_density              ! kg/s x J/kg = J/s
-            berg_grid%calving_hflx (ii,ij) = berg_grid%calving_hflx (ii,ij) + heat    * z1_e1e2    ! W/m2
-            CALL melt_budget(ii, ij, Mnew, heat, this%mass_scaling, dM, dMbitsE, dMbitsM, dMb, dMe, dMv, z1_dt_e1e2 )
+            zmelt    = ( zdM - ( zdMbitsE - zdMbitsM ) ) * z1_dt   ! kg/s
+            berg_grid%floating_melt(ii,ij) = berg_grid%floating_melt(ii,ij) + zmelt    * z1_e1e2    ! kg/m2/s
+            zheat = zmelt * pt%heat_density              ! kg/s x J/kg = J/s
+            berg_grid%calving_hflx (ii,ij) = berg_grid%calving_hflx (ii,ij) + zheat    * z1_e1e2    ! W/m2
+            CALL melt_budget( ii, ij, zMnew, zheat, this%mass_scaling,       &
+            &                         zdM, zdMbitsE, zdMbitsM, zdMb, zdMe,   &
+            &                         zdMv, z1_dt_e1e2 )
          ELSE
             WRITE(numout,*) 'thermodynamics: berg ',this%number(:),' appears to have grounded  at ',narea,ii,ij
@@ -167,17 +170,17 @@
 
          ! Rolling
-         Dn = ( rn_rho_bergs / rho_seawater ) * Tn       ! draught (keel depth)
-         IF( Dn > 0._wp .AND. MAX(Wn,Ln) < SQRT( 0.92*(Dn**2) + 58.32*Dn ) ) THEN
-            T  = Tn
-            Tn = Wn
-            Wn = T
+         zDn = ( rn_rho_bergs / pp_rho_seawater ) * zTn       ! draught (keel depth)
+         IF( zDn > 0._wp .AND. MAX(zWn,zLn) < SQRT( 0.92*(zDn**2) + 58.32*zDn ) ) THEN
+            zT  = zTn
+            zTn = zWn
+            zWn = zT
          endif
 
          ! Store the new state of iceberg (with L>W)
-         pt%mass         = Mnew
-         pt%mass_of_bits = nMbits
-         pt%thickness    = Tn
-         pt%width        = min(Wn,Ln)
-         pt%length       = max(Wn,Ln)
+         pt%mass         = zMnew
+         pt%mass_of_bits = znMbits
+         pt%thickness    = zTn
+         pt%width        = min(zWn,zLn)
+         pt%length       = max(zWn,zLn)
 
          next=>this%next
@@ -185,10 +188,11 @@
 !!gm  add a test to avoid over melting ?
 
-         IF( Mnew <= 0._wp ) THEN       ! Delete the berg if completely melted
+         IF( zMnew <= 0._wp ) THEN       ! Delete the berg if completely melted
             CALL delete_iceberg_from_list( first_berg, this )
             !
          ELSE                            ! Diagnose mass distribution on grid
             z1_e1e2                 = 1._wp / e1e2t(ii,ij) * this%mass_scaling
-            CALL size_budget(ii, ij, Wn, Ln, Abits, this%mass_scaling, Mnew, nMbits, z1_e1e2)
+            CALL size_budget( ii, ij, zWn, zLn, zAbits,   &
+            &                 this%mass_scaling, zMnew, znMbits, z1_e1e2)
          ENDIF
          !
